## mx-service-manager 25.08.05

=== CMakeLists.txt ===
# **********************************************************************
# * Copyright (C) 2023 MX Authors
# *
# * Authors: Adrian <adrian@mxlinux.org>
# *          MX Linux <http://mxlinux.org>
# *
# * This is free software: you can redistribute it and/or modify
# * it under the terms of the GNU General Public License as published by
# * the Free Software Foundation, either version 3 of the License, or
# * (at your option) any later version.
# *
# * This program is distributed in the hope that it will be useful,
# * but WITHOUT ANY WARRANTY; without even the implied warranty of
# * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# * GNU General Public License for more details.
# *
# * You should have received a copy of the GNU General Public License
# * along with this package. If not, see <http://www.gnu.org/licenses/>.
# **********************************************************************/

cmake_minimum_required(VERSION 3.16)

# Get version from debian/changelog
execute_process(
    COMMAND dpkg-parsechangelog -SVersion
    WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
    OUTPUT_VARIABLE PROJECT_VERSION_FROM_CHANGELOG
    OUTPUT_STRIP_TRAILING_WHITESPACE
    RESULT_VARIABLE DPKG_RESULT
)

if(NOT DPKG_RESULT EQUAL 0)
    message(FATAL_ERROR "Failed to get version from debian/changelog using dpkg-parsechangelog")
endif()

project(mx-service-manager
    VERSION ${PROJECT_VERSION_FROM_CHANGELOG}
    DESCRIPTION "Service Manager - MX Linux service management tool"
    LANGUAGES CXX
)

# Set C++ standard
set(CMAKE_CXX_STANDARD 20)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

# Enable compile commands export for IDEs and tools
set(CMAKE_EXPORT_COMPILE_COMMANDS ON)

# Optimize for Ninja builds
if(CMAKE_GENERATOR STREQUAL "Ninja")
    # Enable colored output for Ninja
    if(CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
        add_compile_options(-fdiagnostics-color=always)
    elseif(CMAKE_CXX_COMPILER_ID STREQUAL "Clang")
        add_compile_options(-fcolor-diagnostics)
    endif()
endif()

# Option to use clang for testing builds
option(USE_CLANG "Use clang compiler" OFF)
if(USE_CLANG)
    set(CMAKE_C_COMPILER clang)
    set(CMAKE_CXX_COMPILER clang++)
    set(CMAKE_CXX_COMPILER_ID "Clang")
    message(STATUS "Using clang compiler")
endif()

# Find Qt6 components
find_package(Qt6 REQUIRED COMPONENTS
    Core
    Gui
    Widgets
    LinguistTools
)

# Enable automatic MOC, UIC, and RCC processing
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTOUIC ON)
set(CMAKE_AUTORCC ON)

# Define source files
set(SOURCES
    src/main.cpp
    src/mainwindow.cpp
    src/about.cpp
    src/cmd.cpp
    src/service.cpp
)

set(HEADERS
    src/mainwindow.h
    src/about.h
    src/cmd.h
    src/service.h
    src/common.h
)

set(UI_FILES
    src/mainwindow.ui
)

set(RESOURCE_FILES
    images.qrc
)

# Get all translation files
file(GLOB TRANSLATION_FILES "translations/*.ts")

# Create the executable
add_executable(mx-service-manager
    ${SOURCES}
    ${HEADERS}
    ${UI_FILES}
    ${RESOURCE_FILES}
)

# Link Qt6 libraries
target_link_libraries(mx-service-manager
    Qt6::Core
    Qt6::Gui
    Qt6::Widgets
)

# Set compiler flags
target_compile_options(mx-service-manager PRIVATE
    -Wpedantic
    -pedantic
    -Werror=return-type
    -Werror=switch
    -Werror=uninitialized
    -Werror
)

# Add compiler-specific flags
if(CMAKE_CXX_COMPILER_ID STREQUAL "Clang" OR USE_CLANG)
    target_compile_options(mx-service-manager PRIVATE -Werror=return-stack-address)
else()
    target_compile_options(mx-service-manager PRIVATE -Werror=return-local-addr)
endif()

# Set compile definitions
target_compile_definitions(mx-service-manager PRIVATE
    QT_DEPRECATED_WARNINGS
    QT_DISABLE_DEPRECATED_BEFORE=0x060000
)

# Release-specific optimizations
if(CMAKE_BUILD_TYPE STREQUAL "Release")
    target_compile_definitions(mx-service-manager PRIVATE NDEBUG)
    target_compile_options(mx-service-manager PRIVATE -O3)
    
    # Only add LTO for GCC, not Clang
    if(NOT CMAKE_CXX_COMPILER_ID STREQUAL "Clang" AND NOT USE_CLANG)
        target_compile_options(mx-service-manager PRIVATE -flto=auto)
        target_link_options(mx-service-manager PRIVATE -flto=auto)
    endif()
endif()

# Handle translations
qt6_add_translations(mx-service-manager
    TS_FILES ${TRANSLATION_FILES}
    QM_FILES_OUTPUT_VARIABLE qm_files
)

# Generate version.h file
configure_file(
    "${CMAKE_SOURCE_DIR}/src/version.h.in"
    "${CMAKE_BINARY_DIR}/src/version.h"
    @ONLY
)

# Set target properties
set_target_properties(mx-service-manager PROPERTIES
    OUTPUT_NAME "mx-service-manager"
    RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}
)

# Add build directory to include path for generated version.h
target_include_directories(mx-service-manager PRIVATE ${CMAKE_BINARY_DIR}/src)

# Note: Installation is handled by debian/install for debian packaging
# No install() commands needed here

## mx-service-manager 23.9

=== debian/changelog ===
mx-service-manager (23.9) mx; urgency=medium

  * First official release with latest translations

 -- Adrian <adrian@mxlinux.org>  Tue, 05 Sep 2023 09:07:58 -0400

mx-service-manager (0.23.8) mx; urgency=medium

  * Initial release

 -- Adrian <adrian@mxlinux.org>  Sat, 26 Aug 2023 20:55:12 -0400

=== debian/control ===
Source: mx-service-manager
Section: admin
Priority: optional
Maintainer: Adrian <adrian@mxlinux.org>
Build-Depends: debhelper (>=10), qtbase5-dev, qttools5-dev-tools
Standards-Version: 3.9.8

Package: mx-service-manager
Architecture: any
Depends: xdg-utils | mx-viewer, ${misc:Depends}, ${shlibs:Depends}
Description: mx-service-manager
 mx-service-manager

## mx-service-manager 23.9.01

=== debian/changelog ===
mx-service-manager (23.9.01) mx; urgency=medium

  * Add it to mx-tools
  * Improve sysvinit detection

 -- Adrian <adrian@mxlinux.org>  Fri, 08 Sep 2023 08:23:42 -0400

## mx-service-manager 23.9.02

=== debian/changelog ===
mx-service-manager (23.9.02) mx; urgency=medium

  * Add alias for smbd/samba to make it easier to search
  * List systemd services with 'systemctl list-units' command instead of 'services'

 -- Adrian <adrian@mxlinux.org>  Fri, 08 Sep 2023 12:03:50 -0400

## mx-service-manager 23.10

=== debian/changelog ===
mx-service-manager (23.10) mx; urgency=medium

  * Add tooltip with service description
  * Eliminate some duplicates in the service list
  * Eliminate "not-found" services in systemd list

 -- Adrian <adrian@mxlinux.org>  Sat, 21 Oct 2023 22:30:37 -0400

## mx-service-manager 23.10.01

=== debian/changelog ===
mx-service-manager (23.10.01) mx; urgency=medium

  * Fix: show description tooltip for systemd disabled services and add it to the info box
  * Eliminate more duplicates from service list

 -- Adrian <adrian@mxlinux.org>  Fri, 27 Oct 2023 19:17:09 -0400

## mx-service-manager 23.11

=== debian/changelog ===
mx-service-manager (23.11) mx; urgency=medium

  * Run program as normal user and elevate only when needed
  * Fix random jumping in the service list when changing the status of a service

 -- Adrian <adrian@mxlinux.org>  Tue, 07 Nov 2023 20:26:35 -0500

## mx-service-manager 23.11.01

=== debian/changelog ===
mx-service-manager (23.11.01) mx; urgency=medium

  * Fix: launching from menu from Xfce, not enough permissions to list services

 -- Adrian <adrian@mxlinux.org>  Wed, 08 Nov 2023 11:19:17 -0500

## mx-service-manager 23.11.02

=== debian/changelog ===
mx-service-manager (23.11.02) mx; urgency=medium

  * Fix: run 'service' command with full path instead of running it as root

 -- Adrian <adrian@mxlinux.org>  Wed, 08 Nov 2023 12:53:05 -0500

## mx-service-manager 24.3

=== debian/changelog ===
mx-service-manager (24.3) mx; urgency=medium

  * Update translations 

 -- Adrian <adrian@mxlinux.org>  Sat, 23 Mar 2024 13:08:55 -0400

## mx-service-manager 24.3.01

=== debian/changelog ===
mx-service-manager (24.3.01) mx; urgency=medium

  * Fix running commands as root

 -- Adrian <adrian@mxlinux.org>  Sat, 23 Mar 2024 20:30:31 -0400

## mx-service-manager 24.3.02

=== debian/changelog ===
mx-service-manager (24.3.02) mx; urgency=medium

  * Fix running commands as root

 -- Adrian <adrian@mxlinux.org>  Sat, 23 Mar 2024 20:30:31 -0400

## mx-service-manager 25.4

=== debian/changelog ===
mx-service-manager (25.4) mx; urgency=medium

  * Performance fixes
  * Don't prompt anymore for elevation at startup
  * Update translatons

 -- Adrian <adrian@mxlinux.org>  Tue, 08 Apr 2025 18:23:01 -0400

=== debian/control ===
--- 
+++ 
@@ -8,5 +8,6 @@
 Package: mx-service-manager
 Architecture: any
 Depends: xdg-utils | mx-viewer, ${misc:Depends}, ${shlibs:Depends}
+Recommends: mx-launcher-l10n, gksu | pkexec
 Description: mx-service-manager
  mx-service-manager

=== debian/rules ===
#!/usr/bin/make -f
export QT_SELECT=5

override_dh_auto_clean:
	dh_auto_clean
	rm -f src/translations/*.qm

override_dh_auto_build:
	lrelease translations/*.ts	
	head -n1 debian/changelog | sed -e "s/.*(\([^(]*\)).*/const QString VERSION {\"\1\"};/" > version.h
	dh_auto_build

# Uncomment if building in Virtual Box
override_dh_shlibdeps:
	dh_shlibdeps -- -xvirtualbox-guest-x11 --ignore-missing-info

%:
	dh $@ --no-automatic-dbgsym --parallel

## mx-service-manager 25.8

=== debian/changelog ===
mx-service-manager (25.8) mx; urgency=medium

  * Require elevation at the start of the app for more accurate listing
  * Disable pushed button till the action is completed

 -- Adrian <adrian@mxlinux.org>  Wed, 13 Aug 2025 23:39:41 -0400

mx-service-manager (25.4.01) mx; urgency=medium

  * Update to Qt6

 -- Adrian <adrian@mxlinux.org>  Thu, 24 Apr 2025 18:32:31 -0400

=== debian/control ===
Source: mx-service-manager
Section: admin
Priority: optional
Maintainer: Adrian <adrian@mxlinux.org>
Build-Depends: debhelper-compat (= 13),
               qt6-base-dev,
               qt6-base-dev-tools,
               qt6-tools-dev,
               qt6-tools-dev-tools
Standards-Version: 3.9.8
Vcs-Git: git://github.com/MX-Linux/mx-service-manager
Homepage: https://github.com/MX-Linux/mx-service-manager

Package: mx-service-manager
Architecture: any
Depends: xdg-utils | mx-viewer,
         ${misc:Depends},
         ${shlibs:Depends}
Recommends: mx-launcher-l10n, gksu | pkexec
Description: Service management tool for MX Linux
 MX Service Manager is a graphical utility that allows users to easily
 manage system services on MX Linux. It provides a user-friendly interface
 for:
  * Starting, stopping, and restarting services
  * Checking service status
  * Viewing detailed service information

## mx-service-manager 25.08.04

=== debian/changelog ===
mx-service-manager (25.08.04) mx; urgency=medium

  * Add missing dependencies
  * Remove potentially confusing debug message

 -- Adrian <adrian@mxlinux.org>  Sun, 17 Aug 2025 18:04:29 -0400

=== debian/control ===
--- 
+++ 
@@ -14,6 +14,8 @@
 Package: mx-service-manager
 Architecture: any
 Depends: xdg-utils | mx-viewer,
+         jq,
+         gawk,
          ${misc:Depends},
          ${shlibs:Depends}
 Recommends: mx-launcher-l10n, gksu | pkexec

## mx-service-manager 25.08.05

=== debian/changelog ===
mx-service-manager (25.08.05) mx; urgency=medium

  * Remove extra dependencies

 -- Adrian <adrian@mxlinux.org>  Mon, 18 Aug 2025 00:36:25 -0400

=== debian/control ===
--- 
+++ 
@@ -3,6 +3,7 @@
 Priority: optional
 Maintainer: Adrian <adrian@mxlinux.org>
 Build-Depends: debhelper-compat (= 13),
+               cmake (>= 3.16),
                qt6-base-dev,
                qt6-base-dev-tools,
                qt6-tools-dev,
@@ -14,8 +15,6 @@
 Package: mx-service-manager
 Architecture: any
 Depends: xdg-utils | mx-viewer,
-         jq,
-         gawk,
          ${misc:Depends},
          ${shlibs:Depends}
 Recommends: mx-launcher-l10n, gksu | pkexec

=== debian/rules ===
#!/usr/bin/make -f
export QT_SELECT=6

# Use standard CMake with Make generator for debian compatibility
CMAKE_OPTS = -DCMAKE_BUILD_TYPE=Release

override_dh_auto_configure:
	dh_auto_configure -- $(CMAKE_OPTS)

override_dh_auto_clean:
	dh_auto_clean
	rm -rf build/
	rm -f src/version.h

override_dh_shlibdeps:
	dh_shlibdeps --dpkg-shlibdeps-params=--ignore-missing-info

%:
	dh $@ --buildsystem=cmake --no-automatic-dbgsym

## mx-service-manager 25.08.06

=== debian/changelog ===
mx-service-manager (25.08.06) mx; urgency=medium

  * Fix helper file location

 -- Adrian <adrian@mxlinux.org>  Mon, 18 Aug 2025 12:37:09 -0400

## mx-service-manager 25.10

=== CMakeLists.txt ===
--- 
+++ 
@@ -142,15 +142,19 @@
 target_compile_definitions(mx-service-manager PRIVATE
     QT_DEPRECATED_WARNINGS
     QT_DISABLE_DEPRECATED_BEFORE=0x060000
+    VERSION="${PROJECT_VERSION}"
 )
 
 # Release-specific optimizations
 if(CMAKE_BUILD_TYPE STREQUAL "Release")
     target_compile_definitions(mx-service-manager PRIVATE NDEBUG)
     target_compile_options(mx-service-manager PRIVATE -O3)
-    
-    # Only add LTO for GCC, not Clang
-    if(NOT CMAKE_CXX_COMPILER_ID STREQUAL "Clang" AND NOT USE_CLANG)
+
+    # Add LTO - different flags for different compilers
+    if(CMAKE_CXX_COMPILER_ID STREQUAL "Clang" OR USE_CLANG)
+        target_compile_options(mx-service-manager PRIVATE -flto=thin)
+        target_link_options(mx-service-manager PRIVATE -flto=thin)
+    else()
         target_compile_options(mx-service-manager PRIVATE -flto=auto)
         target_link_options(mx-service-manager PRIVATE -flto=auto)
     endif()
@@ -159,14 +163,8 @@
 # Handle translations
 qt6_add_translations(mx-service-manager
     TS_FILES ${TRANSLATION_FILES}
+    LRELEASE_OPTIONS -compress -nounfinished -removeidentical -silent
     QM_FILES_OUTPUT_VARIABLE qm_files
-)
-
-# Generate version.h file
-configure_file(
-    "${CMAKE_SOURCE_DIR}/src/version.h.in"
-    "${CMAKE_BINARY_DIR}/src/version.h"
-    @ONLY
 )
 
 # Set target properties
@@ -175,8 +173,8 @@
     RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}
 )
 
-# Add build directory to include path for generated version.h
-target_include_directories(mx-service-manager PRIVATE ${CMAKE_BINARY_DIR}/src)
-
-# Note: Installation is handled by debian/install for debian packaging
-# No install() commands needed here
+# Install target (required by Debian build system)
+# Other files are handled by debian/install
+install(TARGETS mx-service-manager
+    RUNTIME DESTINATION bin
+)

=== debian/changelog ===
mx-service-manager (25.10) mx; urgency=medium

  * Add refresh button to repopulates service data keeping the prior
    selection visible
  * Focus search when pressing Ctrl+F

 -- Adrian <adrian@mxlinux.org>  Tue, 21 Oct 2025 11:29:54 -0400

=== debian/control ===
--- 
+++ 
@@ -4,6 +4,7 @@
 Maintainer: Adrian <adrian@mxlinux.org>
 Build-Depends: debhelper-compat (= 13),
                cmake (>= 3.16),
+               ninja-build,
                qt6-base-dev,
                qt6-base-dev-tools,
                qt6-tools-dev,

## mx-service-manager 25.12

=== CMakeLists.txt ===
--- 
+++ 
@@ -71,6 +71,7 @@
     Gui
     Widgets
     LinguistTools
+    Concurrent
 )
 
 # Enable automatic MOC, UIC, and RCC processing
@@ -119,6 +120,7 @@
     Qt6::Core
     Qt6::Gui
     Qt6::Widgets
+    Qt6::Concurrent
 )
 
 # Set compiler flags

=== debian/changelog ===
mx-service-manager (25.12) mx; urgency=medium

  * Add support for user services
  * Service search now matches substrings
  * Improve tooltip loading

 -- Adrian <adrian@mxlinux.org>  Sat, 27 Dec 2025 19:09:25 -0500
